<?php

// No direct access
if (!defined('ABSPATH')) {
    die('Error #845173685');
}


/*
 * Get all recordings
 *
 * $limit - how many to pull at once
 * $offset - from which index should we start displaying
 */
$generatedShortcodes = $this->getGeneratedShortcodes();

?>
<style type="text/css">
    .settings-container {
        display: flex;
        flex-wrap: wrap;
        flex-flow: column;
    }

    .settings-body {
        padding-top: 15px;
        max-width: 90%;
        display: flex;
        flex-wrap: wrap;
        flex-flow: column;
    }

    td.comment {
        font-weight: normal;
        font-size: 12px;
        text-align: left;
    }

    .widefat td,
    .widefat th {
        vertical-align: middle;
    }

    .validate:invalid:required {
        border: 1px solid red;
    }

    .link-button {
        background: none;
        border: none;
        color: #135e96;
        text-decoration: underline;
        cursor: pointer;
    }

    .more-options-option {
        display: none;
    }

    sup {
        background-color: #135e96;
        border-radius: 5px;
        color: white;
        padding: 2px;
    }
</style>
<div class="wrap">

    <?php if (!empty($this->accountHash)) { ?>
        <div class="settings-container">
            <h3>Embed a recorder in your posts or pages</h3>
            <p>How to embed a recorder in a page or blog post:</p>
            <ol>
                <li>Choose the desired settings and generate a shortcode. </li>
                <li>Copy the shortcode and paste it in your post/page where you want the Pipe recorder to show up.</li>
            </ol>
            <div class="settings-body">

                <!-- Generate new shortcode -->
                <table class="widefat">
                    <tr>
                        <th colspan="2" class="alternate"><strong>Generate a shortcode</strong></th>
                        <th class="alternate"></th>
                    </tr>
                    <tr>
                        <td>
                            <label for="recType">Recorder type</label>
                        </td>
                        <td>
                            <select id="recType" style="width: 100%;">
                                <option value="0">Video</option>
                                <option value="1">Audio</option>
                                <option value="2">Screen + Camera</option>
                            </select>
                        </td>
                        <td class="comment">The desired desktop recorder type can be chosen between video, audio, or screen + camera. If audio is selected, the recorders will access just the microphone and record only audio. If screen + camera is selected, the Pipe desktop recorder will display the option to record the screen + camera (this feature is available during the Pipe trial or with a monthly PRO subscription).</td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="env">Environment code</label>
                        </td>
                        <td>
                            <input id="env" name="env" type="text" style="width: 100%;" value="<?php echo esc_attr($this->envId); ?>" />
                        </td>
                        <td class="comment">The 6 character Environment code for the Environment you want the new recordings to be recorded against. It is available in the account dashboard's <a target="_blank" href="https://dashboard.addpipe.com/env_edit">Environment edit</a> page. If empty, the default one will be used. The default one can be changed in "Settings".</td>
                    </tr>
                    <tr>
                        <td>
                            <label for="width">Width</label>
                        </td>
                        <td>
                            <input class="validate" required id="width" name="width" type="text" style="width: 100%;" value="<?php echo esc_attr($this->widthVal); ?>" />
                        </td>
                        <td class="comment">The width of the recorder with the desired CSS unit. The default unit is <strong>px</strong>.</td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="height">Height</label>
                        </td>
                        <td>
                            <input class="validate" required id="height" name="height" type="number" style="width: 100%;" value="<?php echo esc_attr($this->heightVal); ?>" />
                        </td>
                        <td class="comment">The height of the recorder in <strong>pixels</strong>, including the bottom menu (30px). Do not specify the <code>px</code> unit in this field.</td>
                    </tr>
                    <tr>
                        <td>
                            <label for="length">Maximum recording length</label>
                        </td>
                        <td>
                            <input class="validate" required id="length" name="length" type="number" style="width: 100%;" value="<?php echo esc_attr($this->recordingLength); ?>" />
                        </td>
                        <td class="comment">
                            The maximum recording length in <strong>seconds</strong>.
                        </td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="quality">Video resolution</label>
                        </td>
                        <td>
                            <select id="quality" style="width: 100%;">
                                <option value="240p" <?php echo ($this->recordingQuality == '240p') ? 'selected' : '' ?>>240p
                                </option>
                                <option value="240p" <?php echo ($this->recordingQuality == '360p') ? 'selected' : '' ?>>360p
                                </option>
                                <option value="480p" <?php echo ($this->recordingQuality == '480p') ? 'selected' : '' ?>>480p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '720p') ? 'selected' : '' ?>>720p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '1080p') ? 'selected' : '' ?>>1080p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '1440p') ? 'selected' : '' ?>>1440p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '2160p') ? 'selected' : '' ?>>2160p
                                </option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Resolutions from 720p and above are available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>A high quality webcam is needed for recording at high resolutions like 720p.</p>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">
                            <button class="link-button" id="more-options-button">More Options</button>
                        </td>
                    </tr>
                    <!-- MORE OPTIONS START -->
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="asv">Autosave</label>
                        </td>
                        <td>
                            <select id="asv" style="width: 100%;">
                                <option value="1" <?php echo ($this->asv == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->asv == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Whether or not recordings streamed through the desktop recording client should be saved & processed without user interaction.</p>
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="showMenu">Show menu</label>
                        </td>
                        <td>
                            <select id="showMenu" style="width: 100%;">
                                <option value="1" <?php echo ($this->showMenu == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->showMenu == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Whether or not the bottom control menu of the desktop recorder will be visible.</p>
                        </td>
                    </tr>
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="sis">Skip initial screen</label>
                        </td>
                        <td>
                            <select id="sis" style="width: 100%;">
                                <option value="1" <?php echo ($this->sis == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->sis == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>The initial screen will be skipped if set to "Yes".</p>
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="dup">Allow uploads</label>
                        </td>
                        <td>
                            <select id="dup" style="width: 100%;">
                                <option value="1" <?php echo ($this->dup == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->dup == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>This feature is available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>Allows the upload of existing recordings.</p>
                        </td>
                    </tr>
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="countdowntimer">Countdown</label>
                        </td>
                        <td>
                            <input class="validate" required id="countdowntimer" name="countdowntimer" type="number"
                                style="width: 100%;" value="<?php echo esc_attr($this->countdowntimer); ?>" />
                        </td>
                        <td class="comment">
                            A countdown timer in <strong>seconds</strong>. If set to 0, no timer will be displayed.
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="bgblur">Background blurring</label>
                        </td>
                        <td>
                            <select id="bgblur" style="width: 100%;">
                                <option value="1" <?php echo ($this->bgblur == '1') ? 'selected' : '' ?>>Show the option</option>
                                <option value="0" <?php echo ($this->bgblur == '0') ? 'selected' : '' ?>>Don't show the option</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>This feature is available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>Adds a background blurring toggle switch to the camera selection menu.</p>
                        </td>
                    </tr>
                    <!-- MORE OPTIONS END -->
                    <tr>
                        <td colspan=2>
                            <p>
                                <input class="button-primary" type="submit" name="save-settings" id="button-save-settings" value="Generate shortcode" />
                            </p>
                        </td>
                    </tr>
                </table>

                <div style="margin-top: 35px;"></div>

                <!-- Available shortcodes -->
                <table class="widefat">
                    <tr>
                        <th class="alternate"><strong>Copy and paste one of these shortcodes</strong></th>
                    </tr>
                    <?php

                    if (empty($generatedShortcodes)) {
                        echo "
                            <tr>
                                <td>
                                    <h3>No shortcodes have been generated.</h3>
                                </td>
                            </tr>
                            ";
                    } else {
                        $allowed_html = array(
                            'tr' => array(),
                            'td' => array(),
                            'input' => array(
                                'type' => array(),
                                'readonly' => array(),
                                'value' => array()
                            ),
                            'button' => array(
                                'class' => array(),
                                'data-shortcode' => array()
                            ),
                            'br' => array(),
                            'small' => array(),
                            'i' => array(
                                'class' => array()
                            )
                        );

                        foreach ($generatedShortcodes as $arr => $shortcode) {
                            $id = esc_attr($shortcode->shortcode_id);
                            $length = esc_attr($shortcode->length);
                            $quality = esc_attr($shortcode->quality);
                            $envCode = esc_attr($shortcode->env_code);
                            $width = esc_attr($shortcode->width);
                            $height = esc_attr($shortcode->height);
                            $type = esc_attr(
                                $shortcode->ao == 1 ? "Audio" :
                                ($shortcode->srec == 1 ? "Screen + camera" : "Video")
                            );
                            echo wp_kses("
                                <tr>
                                    <td>
                                        <input type='text' readonly value='[pipe_recorder {$id}]' />
                                        <br />
                                        <small>
                                            <strong>Environment code</strong>: {$envCode} • 
                                            <strong>Type</strong>: {$type} • 
                                            <strong>Max length</strong>: {$length} seconds • 
                                            <strong>Quality</strong>: {$quality} • 
                                            <strong>Width</strong>: {$width} • 
                                            <strong>Height</strong>: {$height}px
                                        </small>
                                    </td>
                                </tr>
                        ", $allowed_html);
                        }
                    }
                    ?>
                </table>

            </div><!-- End settings-body -->
            <p>Once you paste in a page or post one of the shortcodes above, registered users or visitors will be able to record video, audio or screen + camera.</p>
        </div><!-- End settings-container -->

        <!-- Account hash check -->
        <?php
    } else {
        ?>
        <div class="error">
            <h4>Missing account hash. Please enter your account hash in the <a href="<?php echo esc_url(admin_url()); ?>admin.php?page=pipe-recorder/load/settings">settings</a> page to create and play recordings.</h4>
        </div>
        <?php
    }
    ?>

</div><!-- End wrap -->


<script type="text/javascript">
    jQuery(document).ready(function ($) {
        // Template buttons
        $(".use-template").click(function () {
            const shortcodeData = $(this).data('shortcode');
            if (!shortcodeData) return;
            // Loop through the object's key-value pairs
            $.each(shortcodeData, function (key, value) {
                // Check if the key starts with "recording_"
                if (key.startsWith("recording_")) {
                    // Set the values of the form
                    const id = key.substring(6);
                    $(`#${id}`).val(value);
                }
            });
        });

        // More options button
        $('#more-options-button').click(function () {
            $('.more-options-option').toggle();
        });

        function validateInputs() {
            // Check each input field
            let invalidInputs = 0;
            $('#length, #width, #height').each(function () {
                if ($(this).val().trim() === '') {
                    // Display error message for empty input
                    alert('Please fill in all required fields.');
                    invalidInputs++;
                    return; // Stop further processing
                }
            });
            return invalidInputs === 0;
        }

        var settingsBody = $('.settings-body');
        var buttonSave = $('#button-save-settings');

        buttonSave.click(function () {
            // Validate inputs before proceeding
            if (!validateInputs()) {
                return false; // Stop further processing
            }

            // Mangle the DOM
            settingsBody.slideUp();
            settingsBody.after("<h3 id='message-saving-settings'>Generating shortcode...</h3>");
            buttonSave.hide();

            // Setup the data object
            data = {
                action: 'addpipe_ajax_shortcode_generator',
                length: $('#length').val(),
                quality: $('#quality option:selected').val(),
                env: $('#env').val(),
                width: $('#width').val(),
                height: $('#height').val(),
                asv: $('#asv').val(),
                ao: $('#recType').val() === "1" ? "1" : "0",
                showMenu: $('#showMenu').val(),
                sis: $('#sis').val(),
                dup: $('#dup').val(),
                srec: $('#recType').val() === "2" ? "1" : "0",
                countdowntimer: $('#countdowntimer').val(),
                bgblur: $('#bgblur').val(),
            };

            // Post it and write the message
            setTimeout(function () {
                $.post(ajaxurl, data, function (response) {
                    $('#message-saving-settings').html(response);
                });
            }, 1000);

            return false;
        });
    });
</script>




<?php
