<?php

// No direct access
if (!defined('ABSPATH')) {
    die('Error #845173685');
}

/*
 * Record new view
 */

?>

<?php
if (!empty($this->accountHash)) {
    ?>
    <style>
        .inside-centered {
            margin: auto;
            text-align: center;
        }

        sup {
            background-color: #135e96;
            border-radius: 5px;
            color: white;
            padding: 2px;
        }

        .record_body {
            width: 90%;
        }

        .widefat td,
        .widefat th {
            vertical-align: middle;
        }
    </style>
    <div class="wrap">
        <h3>Create a new Recording</h3>
        <div id="poststuff">
            <!-- Make a new recording and embed it on any post or page using the embed code from the <a href="<?php echo esc_url(admin_url('admin.php?page=pipe-recorder/load/recordings')); ?>" target="_self">list of recordings</a>. -->
            <p>Use the recorder below to create a new recording.</p>
            <div id="post-body" class="metabox-holder columns-2 record_body">
                <!-- main content -->
                <div id="post-body-content">
                    <div class="meta-box-sortables ui-sortable">
                        <div>
                            <div class="inside">
                                <div class="inside-centered">
                                    <!-- The Pipe recording client will be visible here -->
                                    <div id="pipe-recorder"></div>
                                </div>
                            </div><!-- .inside -->
                        </div><!-- .postbox -->
                    </div><!-- .meta-box-sortables .ui-sortable -->
                </div><!-- post-body-content -->
                <!-- Default settings -->
                <table class="widefat">
                    <tr>
                        <th colspan="2" class="alternate"><strong>Recorder settings</strong></th>
                        <th class="alternate"></th>
                    </tr>
                    <tr>
                        <td>
                            <label for="recType">Recorder type</label>
                        </td>
                        <td>
                            <select id="recType" style="width: 100%;">
                                <option value="0">Video</option>
                                <option value="1">Audio</option>
                                <option value="2">Screen + Camera</option>
                            </select>
                        </td>
                        <td class="comment">The desired desktop recorder type can be chosen between video, audio, or screen + camera. If audio is selected, the recorders will access just the microphone and record only audio. If screen + camera is selected, the Pipe desktop recorder will display the option to record the screen + camera (this feature is available during the Pipe trial or with a monthly PRO subscription).</td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="env">Environment code</label>
                        </td>
                        <td>
                            <input id="env" name="env" type="text" style="width: 100%;" value="<?php echo esc_attr($this->envId); ?>" />
                        </td>
                        <td class="comment">The 6 character Environment code for the Environment you want the new recordings to be recorded against. It is available in the account dashboard's <a target="_blank" href="https://dashboard.addpipe.com/env_edit">Environment edit</a> page. If empty, the default one will be used. The default one can be changed in "Settings".</td>
                    </tr>
                    <tr>
                        <td>
                            <label for="width">Width</label>
                        </td>
                        <td>
                            <input class="validate" required id="width" name="width" type="text" style="width: 100%;" value="<?php echo esc_attr($this->widthVal); ?>" />
                        </td>
                        <td class="comment">The width of the recorder with the desired CSS unit. The default unit is <strong>px</strong>.</td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="height">Height</label>
                        </td>
                        <td>
                            <input class="validate" required id="height" name="height" type="number" style="width: 100%;" value="<?php echo esc_attr($this->heightVal); ?>" />
                        </td>
                        <td class="comment">The height of the recorder in <strong>pixels</strong>, including the bottom menu (30px). Do not specify the <code>px</code> unit in this field.</td>
                    </tr>
                    <tr>
                        <td>
                            <label for="length">Maximum recording length</label>
                        </td>
                        <td>
                            <input class="validate" required id="length" name="length" type="number" style="width: 100%;" value="<?php echo esc_attr($this->recordingLength); ?>" />
                        </td>
                        <td class="comment">
                            The maximum recording length in <strong>seconds</strong>.
                        </td>
                    </tr>
                    <tr class="alternate">
                        <td>
                            <label for="quality">Video resolution</label>
                        </td>
                        <td>
                            <select id="quality" style="width: 100%;">
                                <option value="240p" <?php echo ($this->recordingQuality == '240p') ? 'selected' : '' ?>>240p
                                </option>
                                <option value="240p" <?php echo ($this->recordingQuality == '360p') ? 'selected' : '' ?>>360p
                                </option>
                                <option value="480p" <?php echo ($this->recordingQuality == '480p') ? 'selected' : '' ?>>480p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '720p') ? 'selected' : '' ?>>720p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '1080p') ? 'selected' : '' ?>>1080p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '1440p') ? 'selected' : '' ?>>1440p
                                </option>
                                <option value="720p" <?php echo ($this->recordingQuality == '2160p') ? 'selected' : '' ?>>2160p
                                </option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Resolutions from 720p and above are available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>A high quality webcam is needed for recording at high resolutions like 720p.</p>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">
                            <button class="link-button" id="more-options-button">More Options</button>
                        </td>
                    </tr>
                    <!-- MORE OPTIONS START -->
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="asv">Autosave</label>
                        </td>
                        <td>
                            <select id="asv" style="width: 100%;">
                                <option value="1" <?php echo ($this->asv == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->asv == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Whether or not recordings streamed through the desktop recording client should be saved & processed without user interaction.</p>
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="showMenu">Show menu</label>
                        </td>
                        <td>
                            <select id="showMenu" style="width: 100%;">
                                <option value="1" <?php echo ($this->showMenu == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->showMenu == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>Whether or not the bottom control menu of the desktop recorder will be visible.</p>
                        </td>
                    </tr>
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="sis">Skip initial screen</label>
                        </td>
                        <td>
                            <select id="sis" style="width: 100%;">
                                <option value="1" <?php echo ($this->sis == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->sis == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>The initial screen will be skipped if set to "Yes".</p>
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="dup">Allow uploads</label>
                        </td>
                        <td>
                            <select id="dup" style="width: 100%;">
                                <option value="1" <?php echo ($this->dup == '1') ? 'selected' : '' ?>>Yes</option>
                                <option value="0" <?php echo ($this->dup == '0') ? 'selected' : '' ?>>No</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>This feature is available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>Allows the upload of existing recordings.</p>
                        </td>
                    </tr>
                    <tr class="alternate more-options-option">
                        <td>
                            <label for="countdowntimer">Countdown</label>
                        </td>
                        <td>
                            <input class="validate" required id="countdowntimer" name="countdowntimer" type="number" style="width: 100%;" value="<?php echo esc_attr($this->countdowntimer); ?>" />
                        </td>
                        <td class="comment">
                            A countdown timer in <strong>seconds</strong>. If set to 0, no timer will be displayed.
                        </td>
                    </tr>
                    <tr class="more-options-option">
                        <td>
                            <label for="bgblur">Background blurring</label>
                        </td>
                        <td>
                            <select id="bgblur" style="width: 100%;">
                                <option value="1" <?php echo ($this->bgblur == '1') ? 'selected' : '' ?>>Show the option</option>
                                <option value="0" <?php echo ($this->bgblur == '0') ? 'selected' : '' ?>>Don't show the option</option>
                            </select>
                        </td>
                        <td class="comment" style="max-width: 250px;">
                            <p>This feature is available during the Pipe trial or with a monthly PRO subscription.</p>
                            <p>Adds a background blurring toggle switch to the camera selection menu.</p>
                        </td>
                    </tr>
                    <!-- MORE OPTIONS END -->
                    <tr>
                        <td colspan=2>
                            <p>
                                <input class="button-primary" type="submit" name="save-settings" id="button-save-settings"
                                    value="Generate" />
                            </p>
                        </td>
                    </tr>
                </table>
            </div><!-- #post-body .metabox-holder .columns-2 -->
            <br class="clear">
        </div><!-- #poststuff -->
    </div>


    <style type="text/css">
        #accountHashCheck-missing {
            color: red;
            font-weight: bold;
            padding: 20px;
            margin-top: 20px;
            margin-bottom: 20px;
            background-color: white;
            border-radius: 15px 15px;
            text-align: center;
        }

        .validate:invalid:required {
            border: 1px solid red;
        }

        .link-button {
            background: none;
            border: none;
            color: #135e96;
            text-decoration: underline;
            cursor: pointer;
        }

        .more-options-option {
            display: none;
        }
    </style>

    <script type="text/javascript">
        // The global recorder object
        let RECORDER_OBJECT = null;

        jQuery(document).ready(function ($) {
            // More options button
            $('#more-options-button').click(function () {
                $('.more-options-option').toggle();
            });

            function validateInputs() {
                // Check each input field
                let invalidInputs = 0;
                $('#length, #width, #height').each(function () {
                    if ($(this).val().trim() === '') {
                        // Display error message for empty input
                        alert('Please fill in all required fields.');
                        invalidInputs++;
                        return; // Stop further processing
                    }
                });
                return invalidInputs === 0;
            }

            var buttonSave = $('#button-save-settings');

            buttonSave.click(function () {
                // Validate inputs before proceeding
                if (!validateInputs()) {
                    return false; // Stop further processing
                }

                // Setup the data object
                data = {
                    size: {
                        width: $('#width').val(),
                        height: $('#height').val(),
                    },
                    mrt: $('#length').val(),
                    qualityurl: "avq/" + $('#quality option:selected').val() + ".xml",
                    eid: $('#env').val(),
                    asv: $('#asv').val(),
                    ao: $('#recType').val() === "1" ? "1" : "0",
                    showMenu: $('#showMenu').val(),
                    sis: $('#sis').val(),
                    dup: $('#dup').val(),
                    srec: $('#recType').val() === "2" ? "1" : "0",
                    countdowntimer: $('#countdowntimer').val(),
                    bgblur: $('#bgblur').val(),
                    avrec: 1,
                    accountHash: "<?php echo esc_attr($this->accountHash); ?>",
                    payload: '<?php echo esc_attr($this->accountHash) . ',' . esc_attr(get_current_user_id()) . ',' . esc_attr($this->getThePostId()); ?>' + `,${$('#env').val()}`
                };

                if (!PipeSDK) return; // PipeSDK has not loaded

                if (RECORDER_OBJECT !== null) {
                    RECORDER_OBJECT.remove && RECORDER_OBJECT.remove(); // Remove the old recorder
                }

                PipeSDK.insert("pipe-recorder", data, (recorderObject) => {
                    RECORDER_OBJECT = recorderObject;
                })
            });

            // Simulate a button click
            buttonSave.click();
        })
    </script>
<?php } else { ?>
    <div class="error">
        <h4>Missing account hash. Please enter your account hash in the <a href="<?php echo esc_url(admin_url('admin.php?page=pipe-recorder/load/settings')); ?>">settings</a> page to create and play recordings.</h4>
    </div>
<?php } ?>