<?php

// No direct access
if (!defined('ABSPATH')) {
    die('Error #845173685');
}

?>
<style type="text/css">
    .settings-container {
        display: flex;
        flex-wrap: wrap;
        flex-flow: column;
    }

    .settings-body {
        padding-top: 15px;
        max-width: 90%;
        display: flex;
        flex-wrap: wrap;
        flex-flow: column;
    }

    td.comment {
        font-weight: normal;
        font-size: 12px;
        text-align: left;
        max-width: 300px;
    }

    .widefat td, .widefat th {
        vertical-align: middle;
    }
</style>

<style type="text/css">
    .go-green,
    .go-red,
    .go-yellow {
        display: inline-block;
        padding: 2px 4px;
        border-radius: 2px;
        ;
        color: white;
        font-weight: bolder;
    }

    .go-green {
        background-color: green;
    }

    .go-red {
        background-color: red;
    }

    .go-yellow {
        background: darkgoldenrod;
    }

    .postbox {
        /*margin: auto;*/
        text-align: center;
        padding: 10px;
    }

    code {
        user-select: all;
    }
</style>

<div class="wrap">
    <div class="settings-container">
        <h3>Get an addpipe.com account</h3>
        <p>A Pipe account is needed to use this plugin and the <a href="https://addpipe.com" target="_blank">Pipe Platform</a>. If you don't have an account, you can sign up for a free, fully featured, 14 days trial. Just go to <a href="https://dashboard.addpipe.com/signup" target="_blank">https://dashboard.addpipe.com/signup</a> and create your account, it only takes 1 minute.</p>
        <a class="button-primary" href="https://dashboard.addpipe.com/signup" target="_blank" style="width:min-content;">Sign-up for a free addpipe.com account</a>
        <br>
        <h3>Your addpipe.com Account Hash</h3>
        <div class="settings-body">
            <!-- General settings -->
            <table class="widefat">
                <tr>
                    <td>
                        <label for="accountHash">
                            Account Hash <br />
                            <?php echo (empty($this->accountHash)) ? "<span style='color: red;'>Missing</span>" : ''; ?>
                        </label>
                    </td>
                    <td>
                        <input id="accountHash" name="accountHash" type="text" style="width: 100%;"
                            value="<?php echo esc_attr($this->accountHash); ?>" />
                    </td>
                    <td class="comment"> The <strong>Account Hash</strong> can be found in your addpipe.com account by clicking on the top right <a href="https://dashboard.addpipe.com/account" target="_blank"><strong>Account</strong></a> link after <a href="https://addpipe.com/signin" target="_blank">signing in</a>.
                    </td>
                </tr>
                <tr>
                    <td>
                        <label for="envId">
                            Default Environment code <br />
                            <?php echo (empty($this->envId)) ? "<span style='color: red;'>Missing</span>" : ''; ?>
                        </label>
                    </td>
                    <td>
                        <input id="envId" name="envId" type="text" style="width: 100%;"
                            value="<?php echo esc_attr($this->envId); ?>" />
                    </td>
                    <td class="comment">The <strong>Environment code</strong> can be found in your addpipe.com account by clicking on the top right <a href="https://dashboard.addpipe.com/env_edit" target="_blank"><strong>Settings</strong> (cog wheels)</a> link after <a href="https://addpipe.com/signin" target="_blank">signing in</a>.
                    </td>
                </tr>
                <tr class="alternate">
                    <td colspan="2">
                        <p><input class="button-primary" type="submit" name="save-settings" id="button-save-settings" value="Save" /></p>
                    </td>
                    <td></td>
                </tr>
            </table>
            <br>
            <h3>Webhook</h3>
            <p>If you want the recordings made through the plugin shortcodes to show up in the Recordings page, you'll have to set up a webhook in your Pipe account under the environment's Webhook section that triggers on <code>video_recorded</code>, <code>video_converted</code> and <code>video_copied_pipe_s3</code> events and that uses the URL below.</p>
            <p><strong>URL:</strong><code><?php echo esc_url(get_admin_url()); ?>admin-ajax.php?action=addpipeWebhook</code></p>
            <a href="https://addpipe.com/docs/plugins/wordpress-plugin/" target="_blank">Learn more about setting up the webhook</a>
            <br>
            <h3>Support</h3>
            <p>If you require support, please contact us at <a href="mailto:support@addpipe.com">support@addpipe.com</a>.</p>
        </div>
    </div>
</div>
<script type="text/javascript">
    jQuery(document).ready(function ($) {

        var settingsBody = $('.settings-body');
        var buttonSave = $('#button-save-settings');

        buttonSave.click(function () {

            // Grab the data
            const accountHash = ($('#accountHash').val() || "").trim();
            const envId = ($('#envId').val() || "").trim();

            if (!accountHash || accountHash.length !== 32) {
                alert("Please enter a valid Account Hash");
                return;
            }

            if (!envId || envId.length !== 6) {
                alert("Please enter a valid Environment code");
                return;
            }

            // Mangle the DOM
            settingsBody.slideUp();
            settingsBody.after("<h3 id='message-saving-settings'>Saving new settings...</h3>");
            buttonSave.hide();

            // Setup the data object
            data = {
                action: 'addpipe_ajax_save_settings',
                accountHash: accountHash,
                envId: envId
            };

            // Post it and write the message
            setTimeout(function () {
                $.post(ajaxurl, data, function (response) {
                    $('#message-saving-settings').html(response);
                });
            }, 500);

            return false;
        });
    });
</script>




<?php
